//************************************************************************************
//**  
//**  File name:     E:\PIC\AVR\SPI_AVR_to_AVR\tiny_to_tiny\receiver.c
//**  Generated by:  Flowcode v4.3.6.61
//**  Date:          Tuesday, September 20, 2011 15:25:20
//**  Licence:       Professional
//**  Registered to: 20ACM8
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_AVR

//Defines for microcontroller
#define MX_AVR
#define MX_TINY
#define MX_EE
#define MX_EE_SIZE 128
#define MX_USI
#define MX_SPI
#define MX_SPI_B
#define MX_SPI_SDI 5
#define MX_SPI_SDO 6
#define MX_SPI_SCK 7
#define MX_UART
#define MX_UART_UCSRC
#define MX_UART_D
#define MX_UART_TX 1
#define MX_UART_RX 0
#define MX_MI2C
#define MX_I2C_B
#define MX_I2C_SDA 5
#define MX_I2C_SCL 7
#define MX_PWM
#define MX_PWM_PORT PORTB
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 DDRB
#define MX_PWM_1 3
#define MX_PWM_TRIS2 DDRB
#define MX_PWM_2 4
#define MX_PWMTYPE 1

//Functions
#define F_CPU 8000000UL
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\eeprom.h>
#include <avr\wdt.h>
#include <MX_util\delay.h>
#include <MX_util\bit_cmds.h>

//Configuration data
#pragma DATA 0x0, 0xdf
#pragma DATA 0x1, 0xff
#pragma DATA 0x2, 0xff

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode AVR V4\FCD\internals.h"

//Macro function declarations
void FCM_READ_SPI();


//Variable declarations
volatile char FCV_TEMP;
volatile char FCV_CHAR;
volatile char FCV_DATA;
volatile char FCV_ADDRES;
volatile short FCV_DATA_INT;

char FCLV_LOOP1;

//Defines:

/**** Macro Substitutions ****
7 = DAC Enable Pin
6 = FRAM Enable Pin
0 = SPI Mask Value
8 = CKP Mask Value
4 = CKE Mask Value
0 = SMP Mask Value
******************************/


//SPI COMPONENT DEFINES
#define SPI_DAC_EN 	7
#define SPI_FRM_EN 	6

#define SPI_SPR		0
#define SPI_CPOL	8
#define SPI_CPHA	4

//FRAM commands
#define FRAM_WREN  	6
#define FRAM_WRDI  	4
#define FRAM_RDSR  	5
#define FRAM_WRSR  	1
#define FRAM_READ  	3
#define FRAM_WRITE 	2

#ifdef MX_SPI_A
  #define MX_SPI_PORT PORTA
  #define MX_SPI_DDR DDRA
#endif
#ifdef MX_SPI_B
  #define MX_SPI_PORT PORTB
  #define MX_SPI_DDR DDRB
#endif
#ifdef MX_SPI_C
  #define MX_SPI_PORT PORTC
  #define MX_SPI_DDR DDRC
#endif
#ifdef MX_SPI_D
  #define MX_SPI_PORT PORTD
  #define MX_SPI_DDR DDRD
#endif
#ifdef MX_SPI_E
  #define MX_SPI_PORT PORTE
  #define MX_SPI_DDR DDRE
#endif
#ifdef MX_SPI_F
  #define MX_SPI_PORT PORTF
  #define MX_SPI_DDR DDRF
#endif
#ifdef MX_SPI_G
  #define MX_SPI_PORT PORTG
  #define MX_SPI_DDR DDRG
#endif
#ifdef MX_SPI_H
  #define MX_SPI_PORT PORTH
  #define MX_SPI_DDR DDRH
#endif
#ifdef MX_SPI_I
  #define MX_SPI_PORT PORTI
  #define MX_SPI_DDR DDRI
#endif
#ifdef MX_SPI_J
  #define MX_SPI_PORT PORTJ
  #define MX_SPI_DDR DDRJ
#endif
#ifdef MX_SPI_K
  #define MX_SPI_PORT PORTK
  #define MX_SPI_DDR DDRK
#endif
#ifdef MX_SPI_L
  #define MX_SPI_PORT PORTL
  #define MX_SPI_DDR DDRL
#endif




//SPI_Legacy(0): //Macro function declarations

static void FCD_SPI_Legacy0_SPI_Init();
static void FCD_SPI_Legacy0_SPI_Uninit();
static void FCD_SPI_Legacy0_SPI_Send_Char(char Char);
static char FCD_SPI_Legacy0_SPI_Get_Char();
static void FCD_SPI_Legacy0_DAC_Send_Char(char Char);
static void FCD_SPI_Legacy0_NVM_Send_Char(char hi_addr, char lo_addr, char Char);
static char FCD_SPI_Legacy0_NVM_Get_Char(char hi_addr, char lo_addr);
static char FCD_SPI_Legacy0_FramOutput(char Char);
static void FCD_SPI_Legacy0_EnableFRAM();
static void FCD_SPI_Legacy0_DisableFRAM();
static void FCD_SPI_Legacy0_SPI_Init_Slave();
//Defines:

/**** Macro Substitutions ****
PORTB = LED Port Register
DDRB = LED Data Direction Register
1 = LED Pin Mask
1 = LED Active Polarity
******************************/




//LED(0): //Macro function declarations

static void FCD_LED0_LEDOn();
static void FCD_LED0_LEDOff();



//SPI_Legacy(0): //Macro implementations


static void FCD_SPI_Legacy0_SPI_Init()
{
	
		//GetSPI_InitCode
	  #ifndef MX_SPI
		#error "Chip does not have SPI capability"
	  #endif

		//initialise spi

		clear_bit(MX_SPI_DDR,MX_SPI_SDI);
		set_bit(MX_SPI_DDR,MX_SPI_SDO);
		set_bit(MX_SPI_DDR,MX_SPI_SCK);
		set_bit(MX_SPI_DDR,SPI_DAC_EN);
		set_bit(MX_SPI_DDR,SPI_FRM_EN);

		//disable SPI devices
		set_bit(MX_SPI_PORT, SPI_DAC_EN);
		set_bit(MX_SPI_PORT, SPI_FRM_EN);

	  #ifdef MX_USI
		USICR = (1 << USIWM0);
	  #else
		SPCR = ((1 << SPE) | (1 << MSTR) | SPI_CPOL | SPI_CPHA | SPI_SPR);
	  #endif


}

static void FCD_SPI_Legacy0_SPI_Uninit()
{
	
		//GetSPI_UninitCode
	  #ifndef MX_SPI
		asm error "Chip does not have SPI capability"
	  #endif

	  #ifdef MX_USI
		USICR = 0;
	  #else
		clear_bit(SPCR, SPE);
	  #endif

}

static void FCD_SPI_Legacy0_SPI_Send_Char(char Char)
{
		//GetSPI_Send_CharCode
	  #ifndef MX_SPI
		#error "Chip does not have SPI capability"
	  #endif

		//send the Char
	  #ifdef MX_USI
		unsigned int i;
		USISR = 0;
	 	USIDR = Char;
		for (i = 0; i < 8; i++)
		{
			USICR = (1 << USIWM0) | (1 << USITC);
			delay_us(1);
			USICR = (1 << USIWM0) | (1 << USITC) | (1 << USICLK);
			delay_us(1);
		}
	  #else
		SPDR = Char;

		//wait until sspbuf is empty
		while ((SPSR & (1 << SPIF)) == 0);
	  #endif

}

static char FCD_SPI_Legacy0_SPI_Get_Char()
{
		//GetSPI_Get_CharCode
		char retVal = 0;

	  #ifndef MX_SPI
		asm error "Chip does not have SPI capability"
	  #endif

	  #ifdef MX_USI
		unsigned int i;
		USISR = 0;
		for (i = 0; i < 8; i++)
		{
			USICR = (1 << USIWM0) | (1 << USITC);
			delay_us(1);
			USICR = (1 << USIWM0) | (1 << USITC) | (1 << USICLK);
			delay_us(1);
		}
		retVal = USIDR;
	  #else
		// Clear SPIF
		retVal = SPSR;

		//send a dummy Char
		SPDR = 0x5a;

		//wait until sspbuf is empty
		while ((SPSR & (1 << SPIF)) == 0);

		//receive the Char
		retVal = SPDR;
	  #endif

		return (retVal);

}

static void FCD_SPI_Legacy0_DAC_Send_Char(char Char)
{
		//GetDAC__Send_Char Code
	  #ifndef MX_SPI
		asm error "Chip does not have SPI capability"
	  #endif

		char dac_val;

		//enable dac
		clear_bit(MX_SPI_PORT, SPI_DAC_EN);

	  #ifdef MX_USI
		unsigned int i;
		USISR = 0;
		 USIDR = (Char & 0xF0) >> 4;
		for (i = 0; i < 8; i++)
		{
			USICR = (1 << USIWM0) | (1 << USITC);
			delay_us(1);
			USICR = (1 << USIWM0) | (1 << USITC) | (1 << USICLK);
			delay_us(1);
		}

		 USIDR = (Char & 0x0F) << 4;
		for (i = 0; i < 8; i++)
		{
			USICR = (1 << USIWM0) | (1 << USITC);
			delay_us(1);
			USICR = (1 << USIWM0) | (1 << USITC) | (1 << USICLK);
			delay_us(1);
		}

	  #else
		dac_val = SPDR;
		dac_val = (Char & 0xF0) >> 4;
		SPDR = dac_val;
		while ((SPSR & (1 << SPIF)) == 0);

		dac_val = (Char & 0x0F) << 4;
		SPDR = dac_val;
		while ((SPSR & (1 << SPIF)) == 0);
	  #endif

		//disable dac
		set_bit(MX_SPI_PORT, SPI_DAC_EN);

}

static void FCD_SPI_Legacy0_NVM_Send_Char(char hi_addr, char lo_addr, char Char)
{
		//GetNVM_Send_CharCode
		#ifndef MX_SPI
		    asm error "Chip does not have SPI capability"
		#endif

		//enable writes
		FCD_SPI_Legacy0_EnableFRAM();
		FCD_SPI_Legacy0_FramOutput(FRAM_WREN);
		FCD_SPI_Legacy0_DisableFRAM();

		//send write-fram command, address and data
		FCD_SPI_Legacy0_EnableFRAM();
		FCD_SPI_Legacy0_FramOutput(FRAM_WRITE);
		FCD_SPI_Legacy0_FramOutput(hi_addr);
		FCD_SPI_Legacy0_FramOutput(lo_addr);
		FCD_SPI_Legacy0_FramOutput(Char);
		FCD_SPI_Legacy0_DisableFRAM();

}

static char FCD_SPI_Legacy0_NVM_Get_Char(char hi_addr, char lo_addr)
{
		//GetNVM_Send_CharCode
		char retVal;

		#ifndef MX_SPI
		    asm error "Chip does not have SPI capability"
		#endif

		FCD_SPI_Legacy0_EnableFRAM();

		//send read-fram command and address
		FCD_SPI_Legacy0_FramOutput(FRAM_READ);
		FCD_SPI_Legacy0_FramOutput(hi_addr);
		FCD_SPI_Legacy0_FramOutput(lo_addr);

		//read the data
		retVal = FCD_SPI_Legacy0_FramOutput(0x5A);  //don't care byte of 0x5A

		FCD_SPI_Legacy0_DisableFRAM();

		return(retVal);

}

static char FCD_SPI_Legacy0_FramOutput(char Char)
{
		//GetFramOutputCode
		char retVal;

	  #ifdef MX_USI
		unsigned int i;
		USISR = 0;
		 USIDR = Char;
		for (i = 0; i < 8; i++)
		{
			USICR = (1 << USIWM0) | (1 << USITC);
			delay_us(1);
			USICR = (1 << USIWM0) | (1 << USITC) | (1 << USICLK);
			delay_us(1);
		}
		retVal = USIDR;
	  #else
		retVal = SPSR;											// Clear SPIF

		SPDR = Char;

		//wait until byte has been received
		while ((SPSR & (1 << SPIF)) == 0);

		retVal = SPDR;
	  #endif

		return (retVal);

}

static void FCD_SPI_Legacy0_EnableFRAM()
{
		//enable FRAM
		clear_bit(MX_SPI_PORT, SPI_FRM_EN);

}

static void FCD_SPI_Legacy0_DisableFRAM()
{
		//disable FRAM
		set_bit(MX_SPI_PORT, SPI_FRM_EN);

}

static void FCD_SPI_Legacy0_SPI_Init_Slave()
{
	
		//GetSPI_InitCode
	  #ifndef MX_SPI
		#error "Chip does not have SPI capability"
	  #endif

		//initialise spi

		clear_bit(MX_SPI_DDR,MX_SPI_SDI);	// Inputs
	//	set_bit(MX_SPI_PORT,MX_SPI_SDI);	// Pull-ups
		set_bit(MX_SPI_DDR,MX_SPI_SDO);		// Outputs
		//set_bit(MX_SPI_DDR,MX_SPI_SCK);
		clear_bit(MX_SPI_DDR,MX_SPI_SCK); 	// Inputs added mim
	//	set_bit(MX_SPI_PORT,MX_SPI_SCK);	// Pull-ups

	//	set_bit(MX_SPI_DDR,SPI_DAC_EN);
	//	set_bit(MX_SPI_DDR,SPI_FRM_EN);

		//disable SPI devices
	//	set_bit(MX_SPI_PORT, SPI_DAC_EN);
	//	set_bit(MX_SPI_PORT, SPI_FRM_EN);

	  #ifdef MX_USI
	 // Configure USI to 3-wire slave mode
		USICR = (1 << USIWM0) | (1 << USICS1);// | (1 << USICS0); // added mim
	  #else
		SPCR = ((1 << SPE) | (1 << MSTR) | SPI_CPOL | SPI_CPHA | SPI_SPR);
	  #endif



}



//LED(0): //Macro implementations


static void FCD_LED0_LEDOn()
{
	
		DDRB = DDRB | 1;			//Convert pin to output

		if( 1 )					//Active high polarity
			PORTB = PORTB | 1;
		else					//Active low polarity
			PORTB = PORTB & ~1;

}

static void FCD_LED0_LEDOff()
{
	
		DDRB = DDRB | 1;			//Convert pin to output

		if( 1 )					//Active high polarity
			PORTB = PORTB & ~1;
		else					//Active low polarity
			PORTB = PORTB | 1;

}

//Macro implementations

void FCM_READ_SPI()
{
	
	//C Code
	//C Code:
	FCV_CHAR = USIDR;


	//Decision
	//Decision: char=ADDRES?
	if (FCV_CHAR==FCV_ADDRES)
	{
		//C Code
		//C Code:
		USIDR=FCV_DATA;


		//Output
		//Output: 1 -> B6
		DDRB = DDRB | 0x40;
		if (1)
			PORTB = (PORTB & 0xbf) | 0x40;
		else
			PORTB = PORTB & 0xbf;


	} else {
		//Input
		//Input: B6 -> Temp
		DDRB = DDRB & 0xbf;
		FCV_TEMP = ((PINB & 0x40) == 0x40);


	}


}

int main()
{
	
	//Initialisation
	MCUCR=0x0a;
	MCUSR=0x00;
	wdt_disable();


	//Interrupt initialisation code
	GIMSK=0x00;


	//?????? ??????????
	//Call Component Macro: SPI_Legacy(0)::SPI_Init_Slave
	FCD_SPI_Legacy0_SPI_Init_Slave();


	//Interrupt
	//Interrupt: Enable SPI
	sei();
	sei();
	USICR|=(1<<USIOIE);



	//Input
	//Input: B6 -> Temp
	DDRB = DDRB & 0xbf;
	FCV_TEMP = ((PINB & 0x40) == 0x40);


	//C Code
	//C Code:
	MCUCR &=~(1<<PUD);
	//MCUCR |=(1<<PUD);


	//C Code
	//C Code:
	DDRA = 0;
	PORTA=7;

	DDRD = 0;
	PORTD=127;

	//FCV_ADDRES=PINA;


	//Input
	//Input: PORT A -> ADDRES
	DDRA = DDRA & 00;
	FCV_ADDRES = PINA;


	//????
	//Loop: While 1
	while (1)
	{
		//Input
		//Input: PORT D -> DATA
		DDRD = DDRD & 00;
		FCV_DATA = PIND;


		//???????
		//Decision: char=ADDRES?
		if (FCV_CHAR==FCV_ADDRES)
		{
			//Loop
			//Loop: Loop 3 times
			for (FCLV_LOOP1=0; FCLV_LOOP1<3; FCLV_LOOP1++)
			{
				//?????? ??????????
				//Call Component Macro: LED(0)::LEDOn
				FCD_LED0_LEDOn();


				//????????
				//Delay: 200 ms
				delay_ms(200);


				//?????? ??????????
				//Call Component Macro: LED(0)::LEDOff
				FCD_LED0_LEDOff();


				//????????
				//Delay: 200 ms
				delay_ms(200);


			}


			//Calculation
			//Calculation:
			//  char = 0
			FCV_CHAR = 0;
			

		}


	}


	//Output
	//Output: 0 -> B6
	DDRB = DDRB | 0x40;
	if (0)
		PORTB = (PORTB & 0xbf) | 0x40;
	else
		PORTB = PORTB & 0xbf;


	//Delay
	//Delay: 3 s
	delay_s(3);


	//Input
	//Input: B6 -> Temp
	DDRB = DDRB & 0xbf;
	FCV_TEMP = ((PINB & 0x40) == 0x40);


	mainendloop: goto mainendloop;
}

	//Handler code for [SPI]
	ISR(USI_OVERFLOW_vect)
	{
	     FCM_READ_SPI();
	     USISR|=(1<<USIOIF);
	}



