//************************************************************************************
//**  
//**  File name:     E:\PIC\AVR\SPI_AVR_to_AVR\tiny_to_tiny\transmitter.c
//**  Generated by:  Flowcode v4.3.6.61
//**  Date:          Wednesday, September 21, 2011 08:50:37
//**  Licence:       Professional
//**  Registered to: 20ACM8
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_AVR

//Defines for microcontroller
#define MX_AVR
#define MX_TINY
#define MX_EE
#define MX_EE_SIZE 128
#define MX_USI
#define MX_SPI
#define MX_SPI_B
#define MX_SPI_SDI 5
#define MX_SPI_SDO 6
#define MX_SPI_SCK 7
#define MX_UART
#define MX_UART_UCSRC
#define MX_UART_D
#define MX_UART_TX 1
#define MX_UART_RX 0
#define MX_MI2C
#define MX_I2C_B
#define MX_I2C_SDA 5
#define MX_I2C_SCL 7
#define MX_PWM
#define MX_PWM_PORT PORTB
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 DDRB
#define MX_PWM_1 3
#define MX_PWM_TRIS2 DDRB
#define MX_PWM_2 4
#define MX_PWMTYPE 1

//Functions
#define F_CPU 8000000UL
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\eeprom.h>
#include <avr\wdt.h>
#include <MX_util\delay.h>
#include <MX_util\bit_cmds.h>

//Configuration data
#pragma DATA 0x0, 0xdf
#pragma DATA 0x1, 0xff
#pragma DATA 0x2, 0xff

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode AVR V4\FCD\internals.h"

//Macro function declarations


//Variable declarations
volatile char FCV_ADDRES_TX;
volatile char FCV_TEMP;
volatile char FCV_CHAR_1;
volatile char FCV_CHAR_2;
volatile char FCV_KNOPKA;


//Defines:

/**** Macro Substitutions ****
7 = DAC Enable Pin
6 = FRAM Enable Pin
0 = SPI Mask Value
8 = CKP Mask Value
4 = CKE Mask Value
0 = SMP Mask Value
******************************/


//SPI COMPONENT DEFINES
#define SPI_DAC_EN 	7
#define SPI_FRM_EN 	6

#define SPI_SPR		0
#define SPI_CPOL	8
#define SPI_CPHA	4

//FRAM commands
#define FRAM_WREN  	6
#define FRAM_WRDI  	4
#define FRAM_RDSR  	5
#define FRAM_WRSR  	1
#define FRAM_READ  	3
#define FRAM_WRITE 	2

#ifdef MX_SPI_A
  #define MX_SPI_PORT PORTA
  #define MX_SPI_DDR DDRA
#endif
#ifdef MX_SPI_B
  #define MX_SPI_PORT PORTB
  #define MX_SPI_DDR DDRB
#endif
#ifdef MX_SPI_C
  #define MX_SPI_PORT PORTC
  #define MX_SPI_DDR DDRC
#endif
#ifdef MX_SPI_D
  #define MX_SPI_PORT PORTD
  #define MX_SPI_DDR DDRD
#endif
#ifdef MX_SPI_E
  #define MX_SPI_PORT PORTE
  #define MX_SPI_DDR DDRE
#endif
#ifdef MX_SPI_F
  #define MX_SPI_PORT PORTF
  #define MX_SPI_DDR DDRF
#endif
#ifdef MX_SPI_G
  #define MX_SPI_PORT PORTG
  #define MX_SPI_DDR DDRG
#endif
#ifdef MX_SPI_H
  #define MX_SPI_PORT PORTH
  #define MX_SPI_DDR DDRH
#endif
#ifdef MX_SPI_I
  #define MX_SPI_PORT PORTI
  #define MX_SPI_DDR DDRI
#endif
#ifdef MX_SPI_J
  #define MX_SPI_PORT PORTJ
  #define MX_SPI_DDR DDRJ
#endif
#ifdef MX_SPI_K
  #define MX_SPI_PORT PORTK
  #define MX_SPI_DDR DDRK
#endif
#ifdef MX_SPI_L
  #define MX_SPI_PORT PORTL
  #define MX_SPI_DDR DDRL
#endif




//SPI_Legacy(0): //Macro function declarations

static void FCD_SPI_Legacy0_SPI_Init();
static void FCD_SPI_Legacy0_SPI_Uninit();
static void FCD_SPI_Legacy0_SPI_Send_Char(char Char);
static char FCD_SPI_Legacy0_SPI_Get_Char();
static void FCD_SPI_Legacy0_DAC_Send_Char(char Char);
static void FCD_SPI_Legacy0_NVM_Send_Char(char hi_addr, char lo_addr, char Char);
static char FCD_SPI_Legacy0_NVM_Get_Char(char hi_addr, char lo_addr);
static char FCD_SPI_Legacy0_FramOutput(char Char);
static void FCD_SPI_Legacy0_EnableFRAM();
static void FCD_SPI_Legacy0_DisableFRAM();
//Defines:

/**** Macro Substitutions ****
PINA = Switch Pin Register
DDRA = Switch Data Direction Register
0 = Switch Pin
0 = Switch Polarity Control
5 = Switch Debounce Delay Value
******************************/




//SWITCH(0): //Macro function declarations

static char FCD_SWITCH0_ReadState();
static void FCD_SWITCH0_WaitUntilHigh();
static void FCD_SWITCH0_WaitUntilLow();



//SPI_Legacy(0): //Macro implementations


static void FCD_SPI_Legacy0_SPI_Init()
{
	
		//GetSPI_InitCode
	  #ifndef MX_SPI
		#error "Chip does not have SPI capability"
	  #endif

		//initialise spi
		clear_bit(MX_SPI_DDR,MX_SPI_SDI); 	// Inputs
	//  set_bit(MX_SPI_PORT, MX_SPI_SDI); 	// Pull-ups added mim
		set_bit(MX_SPI_DDR,MX_SPI_SDO); 	// Outputs
		set_bit(MX_SPI_DDR,MX_SPI_SCK); 	// Outputs
	//	set_bit(MX_SPI_DDR,SPI_DAC_EN); //rem mim
	//	set_bit(MX_SPI_DDR,SPI_FRM_EN); //rem mim

		//disable SPI devices
	//	set_bit(MX_SPI_PORT, SPI_DAC_EN);//rem mim
	//	set_bit(MX_SPI_PORT, SPI_FRM_EN);//rem mim

	  #ifdef MX_USI
	// Configure USI to 3-wire master mode
		USICR = (1 << USIWM0);// | (1<<USITC);//|(1<<USICS1)|(1<<USITC)|(1<<USICLK); //added mim
	  #else
		SPCR = ((1 << SPE) | (1 << MSTR) | SPI_CPOL | SPI_CPHA | SPI_SPR);
	  #endif



}

static void FCD_SPI_Legacy0_SPI_Uninit()
{
	
		//GetSPI_UninitCode
	  #ifndef MX_SPI
		asm error "Chip does not have SPI capability"
	  #endif

	  #ifdef MX_USI
		USICR = 0;
	  #else
		clear_bit(SPCR, SPE);
	  #endif

}

static void FCD_SPI_Legacy0_SPI_Send_Char(char Char)
{
		//GetSPI_Send_CharCode
	  #ifndef MX_SPI
		#error "Chip does not have SPI capability"
	  #endif

		//send the Char
	  #ifdef MX_USI
		unsigned int i;
		USISR = 0;
	 	USIDR = Char;

		for (i = 0; i < 8; i++)
		{
		//	delay_us(1);

			USICR |= (1<<USICS1)|(1<<USITC)|(1<<USICLK);
			delay_us(1);
			USICR |= (1<<USICS1)|(1<<USITC)|(1<<USICLK);
			//delay_us(1);
		}
	//		USICR = (1 << USIWM0)|(1<<USICS1)|(1<<USITC)|(1<<USICLK);
	//		delay_us(1);
	//		USICR = (1 << USIWM0)|(1<<USICS1)|(1<<USITC)|(1<<USICLK);
	//		delay_us(1);
	  #else
		SPDR = Char;

		//wait until sspbuf is empty
		while ((SPSR & (1 << SPIF)) == 0);
	  #endif

}

static char FCD_SPI_Legacy0_SPI_Get_Char()
{
		//GetSPI_Get_CharCode
		char retVal = 0;

	  #ifndef MX_SPI
		asm error "Chip does not have SPI capability"
	  #endif

	  #ifdef MX_USI
		unsigned int i;
		USISR = 0;
		for (i = 0; i < 8; i++)
		{
			USICR = (1 << USIWM0) | (1 << USITC);
			delay_us(1);
			USICR = (1 << USIWM0) | (1 << USITC) | (1 << USICLK);
			delay_us(1);
		}
		retVal = USIDR;
	  #else
		// Clear SPIF
		retVal = SPSR;

		//send a dummy Char
		SPDR = 0x5a;

		//wait until sspbuf is empty
		while ((SPSR & (1 << SPIF)) == 0);

		//receive the Char
		retVal = SPDR;
	  #endif

		return (retVal);

}

static void FCD_SPI_Legacy0_DAC_Send_Char(char Char)
{
		//GetDAC__Send_Char Code
	  #ifndef MX_SPI
		asm error "Chip does not have SPI capability"
	  #endif

		char dac_val;

		//enable dac
		clear_bit(MX_SPI_PORT, SPI_DAC_EN);

	  #ifdef MX_USI
		unsigned int i;
		USISR = 0;
		 USIDR = (Char & 0xF0) >> 4;
		for (i = 0; i < 8; i++)
		{
			USICR = (1 << USIWM0) | (1 << USITC);
			delay_us(1);
			USICR = (1 << USIWM0) | (1 << USITC) | (1 << USICLK);
			delay_us(1);
		}

		 USIDR = (Char & 0x0F) << 4;
		for (i = 0; i < 8; i++)
		{
			USICR = (1 << USIWM0) | (1 << USITC);
			delay_us(1);
			USICR = (1 << USIWM0) | (1 << USITC) | (1 << USICLK);
			delay_us(1);
		}

	  #else
		dac_val = SPDR;
		dac_val = (Char & 0xF0) >> 4;
		SPDR = dac_val;
		while ((SPSR & (1 << SPIF)) == 0);

		dac_val = (Char & 0x0F) << 4;
		SPDR = dac_val;
		while ((SPSR & (1 << SPIF)) == 0);
	  #endif

		//disable dac
		set_bit(MX_SPI_PORT, SPI_DAC_EN);

}

static void FCD_SPI_Legacy0_NVM_Send_Char(char hi_addr, char lo_addr, char Char)
{
		//GetNVM_Send_CharCode
		#ifndef MX_SPI
		    asm error "Chip does not have SPI capability"
		#endif

		//enable writes
		FCD_SPI_Legacy0_EnableFRAM();
		FCD_SPI_Legacy0_FramOutput(FRAM_WREN);
		FCD_SPI_Legacy0_DisableFRAM();

		//send write-fram command, address and data
		FCD_SPI_Legacy0_EnableFRAM();
		FCD_SPI_Legacy0_FramOutput(FRAM_WRITE);
		FCD_SPI_Legacy0_FramOutput(hi_addr);
		FCD_SPI_Legacy0_FramOutput(lo_addr);
		FCD_SPI_Legacy0_FramOutput(Char);
		FCD_SPI_Legacy0_DisableFRAM();

}

static char FCD_SPI_Legacy0_NVM_Get_Char(char hi_addr, char lo_addr)
{
		//GetNVM_Send_CharCode
		char retVal;

		#ifndef MX_SPI
		    asm error "Chip does not have SPI capability"
		#endif

		FCD_SPI_Legacy0_EnableFRAM();

		//send read-fram command and address
		FCD_SPI_Legacy0_FramOutput(FRAM_READ);
		FCD_SPI_Legacy0_FramOutput(hi_addr);
		FCD_SPI_Legacy0_FramOutput(lo_addr);

		//read the data
		retVal = FCD_SPI_Legacy0_FramOutput(0x5A);  //don't care byte of 0x5A

		FCD_SPI_Legacy0_DisableFRAM();

		return(retVal);

}

static char FCD_SPI_Legacy0_FramOutput(char Char)
{
		//GetFramOutputCode
		char retVal;

	  #ifdef MX_USI
		unsigned int i;
		USISR = 0;
		 USIDR = Char;
		for (i = 0; i < 8; i++)
		{
			USICR = (1 << USIWM0) | (1 << USITC);
			delay_us(1);
			USICR = (1 << USIWM0) | (1 << USITC) | (1 << USICLK);
			delay_us(1);
		}
		retVal = USIDR;
	  #else
		retVal = SPSR;											// Clear SPIF

		SPDR = Char;

		//wait until byte has been received
		while ((SPSR & (1 << SPIF)) == 0);

		retVal = SPDR;
	  #endif

		return (retVal);

}

static void FCD_SPI_Legacy0_EnableFRAM()
{
		//enable FRAM
		clear_bit(MX_SPI_PORT, SPI_FRM_EN);

}

static void FCD_SPI_Legacy0_DisableFRAM()
{
		//disable FRAM
		set_bit(MX_SPI_PORT, SPI_FRM_EN);

}



//SWITCH(0): //Macro implementations


static char FCD_SWITCH0_ReadState()
{
	
		char switchval;

		clear_bit ( DDRA, 0 );				//Convert pin to input
		asm("nop");							//Allow input voltage to settle

		if (test_bit( PINA, 0 ))				//Read state on input
			switchval = 1;
		else
			switchval = 0;

		if ( 0 == 1 )						//Active low polarity
		{
			if (switchval)					//Invert logic
				switchval = 0;
			else
				switchval = 1;
		}
		return (switchval);			//Return state of switch as least significant bit

}

static void FCD_SWITCH0_WaitUntilHigh()
{
	
		clear_bit ( DDRA, 0 );				//Convert pin to input
		asm("nop");							//Allow input voltage to settle

		if ( 0  == 0 )							//Active high polarity
		{
			while (test_bit( PINA, 0 ) == 0);	//Wait for pin to go high
		}
		else									//Active low polarity
		{
			while (test_bit( PINA, 0 ));			//Wait for pin to go low
		}
		if ( 5 )								//Timeout specified?
			Wdt_Delay_Ms(5);

}

static void FCD_SWITCH0_WaitUntilLow()
{
	
		clear_bit ( DDRA, 0 );					//Convert pin to input
		asm("nop");								//Allow input voltage to settle

		if ( 0 == 0 )							//Active high polarity
		{
			while (test_bit( PINA, 0 ));			//Wait for pin to go low
		}
		else									//Active low polarity
		{
			while (test_bit( PINA, 0 ) == 0);	//Wait for pin to go high
		}
		if ( 5 )								//Timeout specified?
			Wdt_Delay_Ms(5);

}

//Macro implementations

int main()
{
	
	//Initialisation
	MCUCR=0x0a;
	MCUSR=0x00;
	wdt_disable();


	//Interrupt initialisation code
	GIMSK=0x00;


	//?????? ??????????
	//Call Component Macro: SPI_Legacy(0)::SPI_Init
	FCD_SPI_Legacy0_SPI_Init();


	//C Code
	//C Code:
	//MCUCR &=~(1<<PUD);
	MCUCR |=(1<<PUD);


	//????
	//Loop: While 1
	while (1)
	{
		//?????? ??????????
		//Call Component Macro: knopka=SWITCH(0)::ReadState
		FCV_KNOPKA = FCD_SWITCH0_ReadState();


		//???????
		//Decision: knopka?
		if (FCV_KNOPKA)
		{
			//??????????
			//Calculation:
			//  ADDRES_TX = ADDRES_TX+1
			FCV_ADDRES_TX = FCV_ADDRES_TX+1;
			

			//Output
			//Output: ADDRES_TX -> PORT B
			DDRB = DDRB | 0x03;
			PORTB = (PORTB & 0xfc) | FCV_ADDRES_TX;


			//?????? ??????????
			//Call Component Macro: SPI_Legacy(0)::SPI_Send_Char(ADDRES_TX)
			FCD_SPI_Legacy0_SPI_Send_Char(FCV_ADDRES_TX);


			//C Code
			//C Code:
			//Input
			DDRB = DDRB & 0xdf;
			while (1)
				{
			//Input: B5 -> Temp
				FCV_TEMP = ((PINB & 0x20) == 0x20);
				if ((FCV_TEMP) == 0) break;
				}




			//?????? ??????????
			//Call Component Macro: SPI_Legacy(0)::SPI_Send_Char(0x55)
			FCD_SPI_Legacy0_SPI_Send_Char(0x55);


			//C Code
			//C Code:
			FCV_CHAR_1=USIDR;



			//Output
			//Output: CHAR_1 -> PORT D
			DDRD = 0xFF;
			PORTD = FCV_CHAR_1;


			//????????
			//Delay: 500 ms
			delay_ms(255);
			delay_ms(245);


			//Decision
			//Decision: ADDRES_TX=3?
			if (FCV_ADDRES_TX==3)
			{
				//Calculation
				//Calculation:
				//  ADDRES_TX = 0
				FCV_ADDRES_TX = 0;
				

			}


		}


	}


	//Loop
	//Loop: While Temp
	while (1)
	{
		//Input
		//Input: B5 -> Temp
		DDRB = DDRB & 0xdf;
		FCV_TEMP = ((PINB & 0x20) == 0x20);


		if ((FCV_TEMP) == 0) break;
	}


	mainendloop: goto mainendloop;
}



